package misc;
import java.awt.*;
import java.awt.event.*;

/**
 * Title:        Mini Sharp C
 * Description:  Semestrln prce z pedmt Programovac jazyky a Programovac jazyky pro web
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Pavel Vank
 * @version 1.0
 */

public class Gui extends Frame implements ActionListener {

private Button loadTl;
private Button exitTl;
private Button optsTl;
private Button strtTl;

public static String soubor;

public static Frame vystupTxt = new Frame("MiSC output");
public static TextArea txt = new TextArea(null,0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
public static Button centrTl = new Button("Anchor");

public static Options options = new Options();                                 //Stvorime options

/*****************************************************************************/

/** Graficke prostredi programu MiSC. Z nej se ridi veskera cinnost kompilatoru.
 *  Umoznuje nacist zdrojovy text, prelozit a ukoncit praci. Soucasti je i vystupni
 *  okno.
 */

public Gui() {
  this.setTitle("Mini Sharp C");
  this.setBackground(Color.lightGray);
  this.setBounds(10,10,350,60);
  this.setLayout(new GridLayout());
  this.add(loadTl=new Button("Load source"));
  this.add(strtTl=new Button("Start compile"));
  this.add(optsTl=new Button("Options"));
  this.add(exitTl=new Button("Exit program"));
  this.setVisible(true);

  loadTl.addActionListener(this);
  exitTl.addActionListener(this);
  strtTl.addActionListener(this);
  optsTl.addActionListener(this);
  this.addWindowListener(new SysTl(1));

  this.setResizable(false);

  strtTl.setEnabled(false);

}

/*---------------------------------------------------------------------------*/

public void actionPerformed(ActionEvent e) {
 if (e.getActionCommand()=="Load source")  {                                   //Load source
  FileDialog load = new FileDialog(this,"Load source file");
  load.setVisible(true);
  if ((soubor = load.getFile())!=null) {
    Lexan.init(load.getDirectory()+soubor);                                    //Inicializace lexanu
    this.setTitle(soubor+" Mini Sharp C");
    strtTl.setEnabled(true);

    vystupTxt.setBounds(this.getX(),this.getY()+60,350,180);                   //Ukazeme output
    vystupTxt.setLayout(null);
    vystupTxt.add(txt);
    vystupTxt.add(centrTl);
    vystupTxt.setResizable(false);
    vystupTxt.setBackground(Color.lightGray);
    centrTl.setBounds(10,145,50,25);
    centrTl.addActionListener(this);
    txt.setBounds(10,35,330,100);
    vystupTxt.setVisible(true);


  }
 } //Load

 if (e.getActionCommand()=="Exit program") System.exit(1);                     //Exit

 if (e.getActionCommand()=="Options") {
  options.setBounds(Start.gui.getX()+350,Start.gui.getY(),200,240);
  options.setVisible(true);                                                    //Options
 }

 if (e.getActionCommand()=="Anchor")                                           //Centr na outu
   vystupTxt.setBounds(this.getX(),this.getY()+60,350,180);

 if (e.getActionCommand()=="Start compile") {                                  //Start
  strtTl.setEnabled(false);                        //Pred dalsi kompilaci se musi znova nahrat zdroj

  Kernel.init();                                   //Nastaveni delky promennych...

  try {
        Syntan.start();                                  //Vytvori strom
        Start.sharp.generOut();                          //Generuje vystup. soubor
        txt.append("File "+soubor+": Compiled succesfully\n");
      }
      catch (Err err) {
        txt.append(err.getMessage()+"\n");
      }
      catch (NullPointerException npe) {
        txt.append("Internal error (NullPointerException)\n");
        npe.printStackTrace();
      }
 }

} //Action
} //Gui

/*****************************************************************************/

class SysTl extends WindowAdapter {
 int typ;
 public SysTl(int typ) {this.typ=typ;}
 public void windowClosing(WindowEvent e) {
  if (typ==1) System.exit(1);
 }
} //SysTl



/*****************************************************************************/

