package misc;

import java.util.*;

/**
 * Title:        Mini Sharp C
 * Description:  Semestrln prce z pedmt Programovac jazyky a Programovac jazyky pro web
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Pavel Vank
 * @version 1.0
 */

/** Trida Kernel predstavuje obsluhu tabulky promennych.
 *  Umoznuje vkladat promenne a naopak ziskavat jejich adresy.
 */

public class Kernel {

 /** Tabulka promennych obsahujici identifikator a adresu v pameti
  */
 public static Map promenne = new HashMap();                                         // Tabulka promennych

 /** Adresa promenne*/
 public static int adresa;                                                           // Adresa promenne

 private static int delkaInt;                                                        // Delka intu v bytech
 private static int delkaFloat;                                                      // Delka floatu



/*****************************************************************************/

/** Resetuje tabulku promennych, urcuje delky promennych a pocatecni adresu,
 *  od ktere se promenne budou ukladat
 */
public static void init() {
  delkaInt = 2;                                                               // 8 bitovy int
  delkaFloat = 1;                                                             // dtto
  adresa = 0x3000;                                                            // Adresa promennych
  promenne.clear();
}

/*---------------------------------------------------------------------------*/

/** Zkontroluje existenci promenne a pokud jiz neni deklaravana, ulozi ji do
 *  tabulky. V opacnem pripade zahlasi chybu.
 */
public static void putProm(String name) throws Err {                           //Zkontroluje existenci a ulozi
  if (promenne.containsKey(name)) {
    Syntan.chyba("Identifier "+name+"already declared");
  } else {
          promenne.put(name,new Integer(adresa));
          adresa+=delkaInt;

    }
}

/*---------------------------------------------------------------------------*/

/** Vrati adresu identifikatoru*/
public static int getAdresa(String ident) {                                    //Vrati adresu identu
  return ((Integer)promenne.get(ident)).intValue();
}

} //Kernel