package misc;

/**
 * Title:        Mini Sharp C
 * Description:  Semestrln prce z pedmt Programovac jazyky a Programovac jazykz pro web
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Pavel Vank
 * @version 1.0
 */

/** Trida Sharp ja jako jedina implementovana NEstaticky. Ne, ze by to bylo treba,
 *  ale chtel jsem ukazat, ze to take umim ;-)
 *  Obsahuje kompletni implementacne zavisly kod assembleru Z-80, v tomto pripade
 *  specialne pro mikropocitac Sharp MZ-800. Vyuziva pritom nektere rutiny z jeho
 *  originalni ROM.
 */

public class Sharp {

  static byte[] program = new byte[0xffff];                                    //64KB mozneho programu
  byte[] shname = new byte[17];                                                //Sharp name
  short size,exaddr,straddr;                                                   //delka,exec,start

  private String jmeno;                                                        //Jmeno output souboru
  public static int pozice=0;                                                  //Aktualni pozice v programu
  public static int offset=0;                                                  //Posunuti textu vuci 4000

/*****************************************************************************/

public Sharp(String jmeno,String shjmeno) {
  this.setNames(jmeno,shjmeno);
  }

/*---------------------------------------------------------------------------*/

public void setNames(String jmeno,String shjmeno) {
  System.arraycopy(shjmeno.getBytes(),0,this.shname,0,shjmeno.length());
  this.shname[16]=0x0d;                                                        //Koncovy znak
  this.jmeno=jmeno;
 }

/*---------------------------------------------------------------------------*/

public static int recountAdr(int poz) {                                        //Prepocita pozici na abs.
  return (0x1200+poz-128);                                                     //adresu
}

/*---------------------------------------------------------------------------*/

private void welcome() {                                                       //Uvitaci zprava
  int i;
  String mes="---= COMPILED BY MISC =---";
  System.arraycopy(mes.getBytes(),0,this.program,141,mes.length());
  program[i=141+mes.length()]=0x0d;
}

/*---------------------------------------------------------------------------*/

private void head() {                                                          //Zapise hlavicku
  int i;

  program[pozice++]=1;                                                          //Typ = 1 = OBJ
  System.arraycopy(shname,0,program,pozice,shname.length);                                                //Zkopirovani jmena

  pozice=18;
  size=0x5000;
  program[pozice++]=(byte)(size%0x100);
  program[pozice++]=(byte)(size/0x100);                                         //Delka prg
  program[pozice++]=0x00;                                                       //Start
  program[pozice++]=0x12;
  program[pozice++]=0x00;                                                       //Exec
  program[pozice++]=0x12;
  for(i=1;i<=104;i++,pozice++) program[pozice]=0x0;                             //Komentar

/*.............................*/  //Konec hlavicky

  program[pozice++]=(byte)0xcd;   //call LF
  program[pozice++]=(byte)0x06;
  program[pozice++]=(byte)0x00;

}

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/

public static void printf() {

  program[pozice++]=(byte)(0xe1);      //Vezmeme cislo do HL - POP HL
  program[pozice++]=(byte)(0x7d);      //LD A,L

  program[pozice++]=(byte)0xcb;   //SRA A       --- nejdriv prevedeme na ascii horni cast
  program[pozice++]=(byte)(0x2f);       //-- Hex to ascii ale prevadi jen dolni ->shift
  program[pozice++]=(byte)0xcb;   //SRA A
  program[pozice++]=(byte)(0x2f);
  program[pozice++]=(byte)0xcb;   //SRA A
  program[pozice++]=(byte)(0x2f);
  program[pozice++]=(byte)0xcb;   //SRA A
  program[pozice++]=(byte)(0x2f);                  //4x

  program[pozice++]=(byte)0xcd;   //call Hex to Ascii
  program[pozice++]=(byte)0xda;
  program[pozice++]=(byte)0x03;

  program[pozice++]=(byte)0xcd;   //call Print Character
  program[pozice++]=(byte)0x12;
  program[pozice++]=(byte)0x00;

  program[pozice++]=(byte)(0x7d);      //LD A,L

  program[pozice++]=(byte)0xcd;   //call Hex to Ascii
  program[pozice++]=(byte)0xda;
  program[pozice++]=(byte)0x03;

  program[pozice++]=(byte)0xcd;   //call Print Character
  program[pozice++]=(byte)0x12;
  program[pozice++]=(byte)0x00;

  program[pozice++]=(byte)0xcd;   //call New Line
  program[pozice++]=(byte)0x06;
  program[pozice++]=(byte)0x00;

}

/*---------------------------------------------------------------------------*/

public static void assign(int adresa) {       //Na adresu ulozi vrchol zasobniku
  program[pozice++]=(byte)0xe1;   //POP HL
  program[pozice++]=(byte)0x7d;   //LD A,L
  program[pozice++]=(byte)0x32;   //LD (nn),A
  program[pozice++]=(byte)(adresa%0x100);
  program[pozice++]=(byte)(adresa/0x100);
}

/*---------------------------------------------------------------------------*/

public static void printf(String text) {                //Vytiskne text
 byte[] pole = text.toUpperCase().getBytes();
 pole[pole.length-1]=0x0d;                              //Ukoncovaci znak
 System.arraycopy(pole,1,program,0x4000+offset,pole.length-1); //Urizneme pocatecni "

 program[pozice++]=(byte)0x11;  //LD DE,nn
 program[pozice++]=(byte)(recountAdr(0x4000+offset)%0x100);
 program[pozice++]=(byte)(recountAdr(0x4000+offset)/0x100);
 program[pozice++]=(byte)0xcd;  //call Print Message
 program[pozice++]=(byte)0x18;
 program[pozice++]=(byte)0x00;
 program[pozice++]=(byte)0xcd;  //call New Line
 program[pozice++]=(byte)0x06;
 program[pozice++]=(byte)0x00;
 offset+=pole.length-1;                                 //Posunuti offsetu
}

/*---------------------------------------------------------------------------*/
public static void push(int cislo) {                    //Hodi cislo na zasobnik
  program[pozice++]=(byte)0x21;   //LD HL,nn
  program[pozice++]=(byte)(cislo%0x100);
  program[pozice++]=(byte)(cislo/0x100);

  program[pozice++]=(byte)0xe5;   //PUSH HL
}

/*---------------------------------------------------------------------------*/

public static void pushVia(int adresa) {                    //Hodi cislo na adrese na zasobnik
  program[pozice++]=(byte)0x2A;   //LD HL,(nn)
  program[pozice++]=(byte)(adresa%0x100);
  program[pozice++]=(byte)(adresa/0x100);

  program[pozice++]=(byte)0xe5;   //PUSH HL
}

/*---------------------------------------------------------------------------*/

public static void operace(int op) {
  switch(op) {
  case Lexan.PLUS: program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0x85;   //ADD A,L
                   program[pozice++]=(byte)0x6f;   //LD L,A
                   program[pozice++]=(byte)0xe5;   //PUSH HL
                   break;

  case Lexan.MINUS:program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0x95;   //SUB A,L
                   program[pozice++]=(byte)0x6f;   //LD L,A
                   program[pozice++]=(byte)0xe5;   //PUSH HL
                   break;

 case Lexan.KRAT:  program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0xd1;   //POP DE
                   program[pozice++]=(byte)0x3e;   //LD A,n
                   program[pozice++]=(byte)0x10;   //16
                   program[pozice++]=(byte)0x4d;   //LD C,L
                   program[pozice++]=(byte)0x44;   //LD B,H
                   program[pozice++]=(byte)0x21;   //LD HL,0
                   program[pozice++]=(byte)0x00;   //0
                   program[pozice++]=(byte)0x00;   //0
                   program[pozice++]=(byte)0xcb;   //BIT 0,E
                   program[pozice++]=(byte)0x43;
                   program[pozice++]=(byte)0x28;   //JR Z
                   program[pozice++]=(byte)0x01;   //1
                   program[pozice++]=(byte)0x09;   //ADD HL,BC
                   program[pozice++]=(byte)0xcb;   //SLA C
                   program[pozice++]=(byte)0x21;
                   program[pozice++]=(byte)0xcb;   //RL B
                   program[pozice++]=(byte)0x10;
                   program[pozice++]=(byte)0xcb;   //RR D
                   program[pozice++]=(byte)0x1a;
                   program[pozice++]=(byte)0xcb;   //RR E
                   program[pozice++]=(byte)0x1b;
                   program[pozice++]=(byte)0x3d;   //DEC A
                   program[pozice++]=(byte)0x20;   //JR NZ
                   program[pozice++]=(byte)0xf0;   //-16
                   program[pozice++]=(byte)0xe5;   //PUSH HL
                   break;

 //-------------------Podminky------------------------------

  case Lexan.JERO: program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0xBD;   //CP L
                   program[pozice++]=(byte)0xc2;   //JP NZ nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   break;

  case Lexan.NERO: program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0xBD;   //CP L
                   program[pozice++]=(byte)0xca;   //JP Z nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   break;

  case Lexan.MENRO:program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0xBD;   //CP L
                   program[pozice++]=(byte)0xDA;   //JP C nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   break;

  case Lexan.MENSI:program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0xBD;   //CP L
                   program[pozice++]=(byte)0xDA;   //JP C nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0xca;   //JP Z nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   break;

  case Lexan.VETSI:program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0xBD;   //CP L
                   program[pozice++]=(byte)0xD2;   //JP NC nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   break;

  case Lexan.VETRO:program[pozice++]=(byte)0xD1;   //POP DE
                   program[pozice++]=(byte)0xe1;   //POP HL
                   program[pozice++]=(byte)0x7B;   //LD A,E
                   program[pozice++]=(byte)0xBD;   //CP L
                   program[pozice++]=(byte)0xda;   //JP C nn
                   int a=pozice;
                   program[pozice++]=(byte)(recountAdr(a+5)%0x100); // OK, pokracujeme
                   program[pozice++]=(byte)(recountAdr(a+5)/0x100);
                   program[pozice++]=(byte)0xc2;   //JP NZ nn
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!
                   program[pozice++]=(byte)0x00;   //   !!!!!!!!!!!!!!!!!!!!
                   break;
  default:;
  }
}

/*---------------------------------------------------------------------------*/

public static void jump(int poz) {
  int adresa=recountAdr(poz);
  program[pozice++]=(byte)0xc3;   //JP nn
  program[pozice++]=(byte)(adresa%0x100);
  program[pozice++]=(byte)(adresa/0x100);

}

/*---------------------------------------------------------------------------*/

public static void konec() {
  program[pozice++]=(byte)0xcd;   //call monitor
  program[pozice++]=(byte)0xad;
  program[pozice++]=(byte)0x00;
}

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/

public void generOut() {                                                       //Spusti generovani
  head();
  //welcome();
  Syntan.strom.preloz();            //Prelozi do strojaku
  konec();                          //Spusti monitor
  Sys.rewriteSoubor(jmeno,program); //Hodi pole do souboru
}

}//Sharp