package misc;
import java.io.*;

/**
 * Title:        Mini Sharp C
 * Description:  Semestrln prce z pedmt Programovac jazyky a Programovac jazyky pro web
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Pavel Vank
 * @version 1.0
 */

 /** Trida Sys slouzi k obsluze souboru - znakoveho vstupniho a binarniho vystupniho.
  *  Je implemetovana staticky, tzn. v programu se nikde netvori jeji instance.
  */

public final class Sys {

/**Cislo znaku aktualni pozice ve vstupnim souboru*/
  public static int sloupec;
/**Cislo radku aktualni pozice ve vstupnim souboru*/
  public static int radek;
 /**Vystupni binarni soubor*/
  public static FileOutputStream vystup;

  private static File soubor;                      //Handler na soubor
  private static FileReader vstup;                 //Vstupni soubo

  private static char znak;                        //Znak nacteny ze souboru


/*****************************************************************************/

private static void infoSoubor() {                                 //Informace o prostredi
  String dirName =  System.getProperty("user.dir");
  System.out.println("MiCS for Java platform started...");
  System.out.println("---------------------------------");
  System.out.println("Actual directory: "+dirName);
  //System.getProperties().list(System.out);
}

/*---------------------------------------------------------------------------*/
/**Priradi a zaroven otevre vstupni znakovy soubor.
   @param jmeno jmeno vstupniho souboru
*/

public static void priradSoubor(String jmeno) {                   //Otevre soubor pro cteni
  try {
    soubor = new File(jmeno);
    vstup = new FileReader(soubor);
    radek=sloupec=1;                                             //Inicializace souradnic
  }
  catch (IOException e) {                                        //Osetreni vyjimky
    System.out.println("Cannot open file "+soubor);
    System.exit(-1);
  }
}

/*---------------------------------------------------------------------------*/
/**Otevre vystupni binarni soubor a zapise do nej pole bytu.
 * @param jmeno jmeno souboru
 * @param program pole bytu pro zapis
 */

public static void rewriteSoubor(String jmeno,byte[] program) {  //Otevre soubor pro cteni a zapise pole
  try {
    vystup = new FileOutputStream(jmeno);
    vystup.write(program);
    vystup.close();
  }
  catch (IOException e) {                                        //Osetreni vyjimky
    System.out.println("Cannot open file "+soubor);
    System.exit(-1);
  }
}

/*---------------------------------------------------------------------------*/
/** Precte jeden znak ze vstupniho souboru a pri dosazeni konce soubor uzavre.
 *  Pri chybe pri praci se souborem ukonci program s navratovym kodem -1.
 */

public static char ctiZnak() {                                   //Cte znak
  try {
    znak=(char)vstup.read();
    if (znak=='\r') {                                            //Pocitani souradnic
      sloupec=1;
      radek+=1;
      } else sloupec+=1;
    if (znak==-1) vstup.close();                                 //Do Znaku a osetrime konec uzavrenim
  }
  catch (IOException e) {
    System.out.println("There's someting wrong with "+soubor+" Terminating...");
    System.exit(-1);                                            //Natvrdo vyhodi!!
  }
  return znak;
}

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/

} //Konec tridy Sys